<?php

class CUnit extends Unit {

	function CUnit(){
		parent::Unit();
		$this->dn_list['title'] = 3;
		$this->dn_list['re_no'] = 4;
	}

	//data----------------------------------------------
	function init_data($name,$pass,$pid,$title){
		parent::init_data($name,$pass,$pid);
		$this->data[3] = $title;    //title
		$this->data[4] = "0";     //re_no
	}

	function increase_re_no(){ ++$this->data[4]; }
	function decrease_re_no(){ --$this->data[4]; }

	//body--------------------------------------------
	function get_log_body() {
		$cbody = parent::get_body();
		$cbody.= "<co>\n";
		return $cbody;
	}

	//Unit----------------------------------------------
	function get_unit(){
		$cunit = $this->get_log_data();
		$cunit.= $this->get_log_body();
		return $cunit;
	}

	function get_show_unit(){
		$c_data = $this->get_data_array();
		$c_body = $this->get_body();
		return array($c_data,$c_body);
	}
}

class RUnit extends Unit {

	function RUnit(){
		parent::Unit();
		$this->dn_list['delete'] = 4;
	}

	//data----------------------------------------------
	function init_data($name,$pass,$pid){
		parent::init_data($name,$pass,$pid);
		$this->data[4] = "no";     //delete
	}

	function set_delete() { $this->data[4] = "ok"; }

	//body--------------------------------------------
	function get_log_body() {
		$rbody = parent::get_body();
		$rbody.= "<re>\n";
		return $rbody;
	}

	//Unit----------------------------------------------
	function get_unit(){
		$runit = $this->get_log_data();
		$runit.= $this->get_log_body();
		return $runit;
	}

	function get_show_unit(){
		$r_data = $this->get_data_array();
		$r_body = $this->get_body();
		return array($r_data,$r_body);
	}
}

class BasicLog extends Log {
	var $list; //UNITw|C^̃Xg

	function BasicLog(){
		$this->list = array();
		parent::Log();
	}

	function set_last($no) { $this->last = $no; }
	function set_null($no) { $this->list[$no] = NULL; }

	function set_log ($log) {
		//e҃f[^
		$contributor_data = array_shift($log);
		$this->top = & new CUnit();
		$this->top->set_data($contributor_data);

		//e
		while (list($key,$value) = each($log)){
			if (preg_match('/^<co>/', $value)) break;
			else $this->top->add_body($value);
		}
		$this->list[0] = & $this->top;

		//Ԏf[^
		$i = 1;
		while (list($key,$value) = each($log)){ //EOF܂Ŏs
			$new_runit = & new RUnit();
			$new_runit->set_data($value);
			while (list($bkey,$bvalue) = each($log)){
				if (preg_match('/^<re>/', $bvalue)) break;
				else $new_runit->add_body($bvalue);
			}
			$this->list[$i]= & $new_runit;
			++$i;
		}
		$this->set_last($i);
	}

	function new_runit ($name,$pass,$pid,$body,$url,$tcl,$bcl,$icon,$type,$fname) {
		$runit = & new RUnit();
		$runit->init_data($name,$pass,$pid);
		$runit->init_odata($url,$tcl,$bcl,$icon,$type,$fname);
		$runit->set_body($body);
		$this->list[$this->last] = & $runit;
		$this->set_last($this->last + 1);
	}

	function del_last_runit ($no) {
		$this->set_last($no - 1);
		$this->set_null($no);
	}

	function set_delete($no,$admin) {
		$runit = & new RUnit();
		$runit->set_data($this->list[$no]->get_log_data());
		$runit->set_delete();

		$del_time = date("yNmdG:i:s",time());
		if($admin){ //Ǘlɂ폜\
			$body = "̕Ԏe(" .$del_time .")ɊǗl폜܂B";
		} else { //e҂ɂ폜\
			$body = "̕Ԏe(" .$del_time .")ɍ폜܂B";
		}
		$runit->add_body($body);
		$this->list[$no] = & $runit;
	}

	// ### Unitf[^

	// CUnit
	function increase_re_no() { $this->top->increase_re_no(); }
	function decrease_re_no() { $this->top->decrease_re_no(); }

	// data
	function get_data($no,$name) { return $this->list[$no]->get_data($name); }
	function get_data_array($no) { return $this->list[$no]->get_data_array(); }
	function get_odata($no,$name) { return $this->list[$no]->get_odata($name); }
	function get_odata_array($no) { return $this->list[$no]->get_odata_array(); }
	function get_body($no) { return $this->list[$no]->get_body(); }

	function get_unit($no) { return $this->list[$no]->get_unit(); }
	function get_show_unit($no) { return $this->list[$no]->get_show_unit(); }

	//Log
	function get_log (){
		$i = 0;
		while ($this->list[$i] != NULL){
			$log.= $this->list[$i]->get_unit();
			++$i;
		}
		return $log;
	}
}

?>