<?php

//
function check_body($body)
{
	global $g_html_tag,$g_auto_link;

	$body = htmlspecialchars($body);

	if ($g_html_tag) {
		$body = preg_replace("/\n/im",'<br>',$body);

		// pł^O߂
		$body = preg_replace('/&lt;hr&gt;/i','<hr width=85%>',$body);
		$body = preg_replace('/&lt;b&gt;(.+)&lt;\/b&gt;/im','<b>$1</b>',$body);
		$body = preg_replace('/&lt;i&gt;(.+)&lt;\/i&gt;/im','<i>$1</i>',$body);
		$body = preg_replace('/&lt;u&gt;(.+)&lt;\/u&gt;/im','<u>$1</u>',$body);
		$body = preg_replace('/&lt;s&gt;(.+)&lt;\/s&gt;/im','<s>$1</s>',$body);
		$body = preg_replace('/&lt;sup&gt;(.+)&lt;\/sup&gt;/im','<sup>$1</sup>',$body);
		$body = preg_replace('/&lt;tt&gt;(.+)&lt;\/tt&gt;/im','<tt>$1</tt>',$body);
		$body = preg_replace('/&lt;sub&gt;(.+)&lt;\/sub&gt;/im','<sub>$1</sub>',$body);
		$body = preg_replace('/&lt;bq&gt;(.+)&lt;\/bq&gt;/im','<blockquote>$1</blockquote>',$body);

		$body = preg_replace("/<br>/im","\n",$body);

		// N
		if ($g_auto_link)
			$body = preg_replace('/(http?:\/\/.+)(\s|$)/im','<a href="$1" target="_blank">$1</a>$2',$body);

		// >  pre
		$body_list = explode("\n",$body);

		$matches = array();
		foreach($body_list as $tmp) {
			preg_match('/^(&gt;|)(.+)/i',$tmp,$matches);

			if (!$matches[0]) {
				if (!$c_pre) $pre.= $tmp ."\n";
				else $pre.= "</pre>" .$tmp ."\n";
				$c_pre = FALSE;
			} else { // 47
				$count = mb_strlen($matches[2],"SJIS");
				if ($count > 47) {
					unset($pbody);
					$div = floor($count / 47);
					$rest = $count % 47;
					for($i = 0; $i < $div; ++$i) {
						$pbody.= '&gt; ' .jsubstr($matches[2], $i * 47, 47) .'<br>';
					}
					$pbody.= '&gt; ' .jsubstr($matches[2], $div * 47, $rest);
				} else $pbody = '&gt; ' .$matches[2];
				if (!$c_pre) $pre.= '<pre class="cb">' .$pbody .'<br>';
				else $pre.= $pbody .'<br>';
				$c_pre = TRUE;
			}
		} if ($c_pre) $pre.= '</pre>';

		$body = $pre;
	}

	return $body;
}

?>