<?php

class QUnit extends Unit {

	function QUnit(){
		parent::Unit();
		$this->dn_list['title'] = 3;
		$this->dn_list['solution'] = 4;
		$this->dn_list['ans_no'] = 10;
	}

	//data----------------------------------------------
	function init_data($name,$pass,$pid,$title){
		parent::init_data($name,$pass,$pid);
		$this->data[3] = $title;    //title
		$this->data[4] = "no";     //solution
		$this->data[10] = "0";      //ans_no
	}

	function set_solution() { $this->data[4] = "ok"; }
	function increase_ans_no(){ ++$this->data[10]; }
	function decrease_ans_no(){ --$this->data[10]; }

	//body--------------------------------------------
	function get_log_body() {
		$body = parent::get_body();
		$body.= "<ques>\n";
		return $body;
	}

	//Unit----------------------------------------------
	function get_unit(){
		$qunit = $this->get_log_data();
		$qunit.= $this->get_log_body();
		return $qunit;
	}

	function get_show_unit(){
		$q_data = $this->get_data_array();
		$q_body = $this->get_body();
		return array($q_data,$q_body);
	}
}

class AUnit extends Unit {

	function AUnit(){
		parent::Unit();
		$this->dn_list['delete'] = 4;
	}

	//data----------------------------------------------
	function init_data($name,$pass,$pid){
		parent::init_data($name,$pass,$pid);
		$this->data[4] = "no";     //delete
	}

	function set_delete() { $this->data[4] = "ok"; }

	//body--------------------------------------------
	function get_log_body() {
		$abody = parent::get_body();
		$abody.= "<ans>\n";
		return $abody;
	}

	//Unit----------------------------------------------
	function get_unit(){
		$aunit = $this->get_log_data();
		$aunit.= $this->get_log_body();
		return $aunit;
	}

	function get_show_unit(){
		$a_data = $this->get_data_array();
		$a_body = $this->get_body();
		return array($a_data,$a_body);
	}
}

class QandALog extends Log {
	var $list; //UNITw|C^̃Xg

	function QandALog(){
		$this->list = array();
		parent::Log();
	}

	function set_last($no) { $this->last = $no; }
	function set_null($no) { $this->list[$no] = NULL; }

	function set_log ($log) {
		//e҃f[^
		$questioner_data = array_shift($log);
		$this->top = & new QUnit();
		$this->top->set_data($questioner_data);

		//ee
		while (list($key,$value) = each($log)){
			if (preg_match('/^<ques>/', $value)) break;
			else $this->top->add_body($value);
		}
		$this->list[0] = & $this->top;

		//Ԏf[^
		$i = 1;
		while (list($key,$value) = each($log)){ //EOF܂Ŏs
			$new_aunit = & new AUnit();
			$new_aunit->set_data($value);
			while (list($bkey,$bvalue) = each($log)){
				if (preg_match('/^<ans>/', $bvalue)) break;
				else $new_aunit->add_body($bvalue);
			}
			$this->list[$i]= & $new_aunit;
			++$i;
		}
		$this->set_last($i);
	}

	function new_aunit ($name,$pass,$pid,$body,$url,$tcl,$bcl,$icon,$type,$fname) {
		$aunit = & new AUnit();
		$aunit->init_data($name,$pass,$pid);
		$aunit->init_odata($url,$tcl,$bcl,$icon,$type,$fname);
		$aunit->set_body($body);
		$this->list[$this->last] = & $aunit;
		$this->set_last($this->last + 1);
	}

	function del_last_aunit ($no) {
		$this->set_last($no - 1);
		$this->set_null($no);
	}

	function set_delete($no,$admin) {
		$aunit = & new AUnit();
		$aunit->set_data($this->list[$no]->get_log_data());
		$aunit->set_delete();

		$del_time = date("yNmdG:i:s",time());
		if($admin){ //Ǘlɂ폜\
			$body = "̕Ԏe(" .$del_time .")ɊǗl폜܂B";
		} else { //e҂ɂ폜\
			$body = "̕Ԏe(" .$del_time .")ɍ폜܂B";
		}
		$aunit->add_body($body);
		$this->list[$no] = & $aunit;
	}

	// ### Unitf[^

	// QUnit
	function set_solution() { $this->top->set_solution(); }
	function increase_ans_no() { $this->top->increase_ans_no(); }
	function decrease_ans_no() { $this->top->decrease_ans_no(); }

	// data
	function get_data($no,$name) { return $this->list[$no]->get_data($name); }
	function get_data_array($no) { return $this->list[$no]->get_data_array(); }
	function get_odata($no,$name) { return $this->list[$no]->get_odata($name); }
	function get_odata_array($no) { return $this->list[$no]->get_odata_array(); }
	function get_body($no) { return $this->list[$no]->get_body(); }

	// Unit
	function get_unit($no) { return $this->list[$no]->get_unit(); }
	function get_show_unit($no) { return $this->list[$no]->get_show_unit(); }

	//Log
	function get_log(){
		$i = 0;
		while ($this->list[$i] != NULL){
			$log.= $this->list[$i]->get_unit();
			++$i;
		}
		return $log;
	}
}

?>