<?php

define(HOME, ''); //z[fBNg
define(LIB_DIR, HOME . 'lib/');    //Cuۊǐ

require_once(LIB_DIR .'init.php');           //ϐ̏
require_once(LIB_DIR .'library.php');        //Cuǂݍ
require_once(LIB_DIR .'file.php');           //fileCuǂݍ

// main
main();
exit;

function main()
{
	global $g_vars,$g_burl,$g_cgi_name,$g_bbs_title,$g_rss_max,$g_rss_php;
	$func_data = array("rss","","main");

	//̓f[^擾
	$init = $g_vars;
	$rss_ver = "1.0";

	//̓f[^`FbN
	if (strlen($init['id']) > 30)
		error("input data illegal.",42,$func_data);

	$ver = $init['v'];

	list($menu_id,$item_id,$no) = explode("_",$init['id']);
	list($menu_name,$module) = mid_info($menu_id);

	if ($item_id) {
		$file_name = file_name("lmlog",$menu_id,$item_id);
		$item_name = item_id_info($menu_id,$item_id);
		$about = $g_burl . $g_rss_php .'?id=' .get_id($menu_id, $item_id) .'&amp;v=' .$ver;
		$rss_title = $g_bbs_title .' / ' .$menu_name .' / ' .$item_name;
		$description = $g_bbs_title . '  / ' .$menu_name ." / " .$item_name . ' XV';
	} else if ($menu_id) {
		$file_name = file_name("lmitem",$menu_id);
		$about = $g_burl . $g_rss_php .'?id=' .$menu_id .'&amp;v=' .$ver ;
		$rss_title = $g_bbs_title .' / ' .$menu_name;
		$description = $g_bbs_title .' / ' .$menu_name . ' XV';
	} else {
		$menu_log_name = file_name("menu");
		$menu_log = read_file($menu_log_name);
		$file_name = DATA_DIR . 'recent.dat';
		$about = $g_burl . $g_rss_php .'&amp;v=' .$ver;
		$rss_title = $g_bbs_title;
		$description = $g_bbs_title . " XV";
	}

	if ($file_name) $log = read_file($file_name);
	$log_time = filemtime($file_name);

	$log_count = count($log);
	if (!$g_rss_max) $g_rss_max = 20;
	if ($log_count > $g_rss_max) $show_rss = $g_rss_max;
	else $show_rss = $log_count;

	for ($i = 0; $i < $show_rss; ++$i) {
		$log_tmp = array_shift($log);
		$log_tmp = preg_replace("/\n/", '', $log_tmp);
		list($time, $id, $name) = explode("\t", $log_tmp);
		if ($item_id){
			$url = $g_burl .$g_cgi_name .'?id=' .get_id($menu_id, $item_id, $id);
			$title = 'No.'.$id;
		} else if ($menu_id) {
			$url = $g_burl .$g_cgi_name .'?id=' .get_id($menu_id, $id);
			$title = $name;
		} else {
			$url = $g_burl .$g_cgi_name .'?id=' .$id;
			list($title,$module) = mid_info($id);
		}

		if (!strcmp($ver,"2")) {
			$date = date('D, d M Y H:i:s T', $time);
			$item.= <<<_XML_
  <item>
   <title>{$title}</title>
   <link>{$url}</link>
   <pubDate>{$date}</pubDate>
  </item>

_XML_;
		} else {
			$date = substr_replace(date('Y-m-d\TH:i:sO', $time),':',-2,0);
			$rdf_li.= "    <rdf:li rdf:resource=\"{$url}\" />\n";

			$item.= <<<_XML_
  <item rdf:about="{$url}">
   <title>{$title}</title>
   <link>{$url}</link>
   <dc:date>{$date}</dc:date>
  </item>

_XML_;
		}
	}

	$rss = '<?xml version="1.0" encoding="utf-8" ?>' ."\n";
	$date = date('Y/m/d (D) H:i:s T', time());

	if (!strcmp($ver,"2")) {
		$update = date('D, d M Y H:i:s T', $log_time);
		$rss.= <<<_XML_
<!-- RSS 2.0 generated by NA-multiBBS rss.php ver.{$rss_ver} on $date -->
<rss version="2.0">
 <channel>
  <title>{$rss_title}</title>
  <link>{$about}</link>
  <description>{$description}</description>
  <pubDate>{$update}</pubDate>
  <language>ja</language>
{$item}
 </channel>
</rss>
_XML_;
	} else {
		$update = substr_replace(date('Y-m-d\TH:i:sO', $log_time),':',-2,0);
		$rss = <<<_XML_
<!-- RSS 1.0 generated by NA-multiBBS rss.php ver.{$rss_ver} on $date -->
<rdf:RDF xmlns="http://purl.org/rss/1.0/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:sy="http://purl.org/rss/1.0/modules/syndication/" xml:lang="ja">
 <channel rdf:about="{$about}">
  <title>{$rss_title}</title>
  <link>{$about}</link>
  <description>{$description}</description>
  <dc:language>ja</dc:language>
  <dc:date>{$update}</dc:date>
  <items>
   <rdf:Seq>
{$rdf_li}
   </rdf:Seq>
  </items>
 </channel>
{$item}
</rdf:RDF>
_XML_;
	}

	header('Content-type: application/xml');
	ob_start();
	print mb_convert_encoding($rss, "UTF-8", "SJIS");
	ob_end_flush();
}

?>