<?php

define(HOME, '');
define(LIB_DIR, 'lib/');

require_once(LIB_DIR . 'init.php');
require_once(LIB_DIR . 'library.php');
require_once(LIB_DIR . 'trackback.php');
require_once(LIB_DIR . 'file.php');           //fileCuǂݍ
require_once(LIB_DIR . 'log.php');            //logCuǂݍ

receive_tb();

// gbNobN̎M
function receive_tb()
{
	global $g_vars,$g_tb,$g_modvar;
	$init = $g_vars;

	$id = $init['id'];
	$url = $init['url'];

	if ($url) tb_check($url,$id);

	$mode = $init['__mode'];

	if ($g_tb && $g_modvar['tb'] && $id && $mode) {
		list($mid,$item,$no) = explode("_", $id);

		// gbNobNf[^ǂݍ
		$tb_file_name = file_name("tb",$mid,$item,$no);
		$tb_data = read_file($tb_file_name);
		if (!$tb_data) $tb_data = array();

		if (file_exists($tb_file_name)) {
			$tb_log_time = filemtime($tb_file_name);
			$last_mod = date("y/m/d H:i:s(D)",$tb_log_time);
		} else $last_mod = "none";

		if (!strcmp($mode,"rss")) tb_rss($mid,$item,$no,$tb_data);
		else if (!strcmp($mode,"view"))
			tb_view($mid,$item,$no,$tb_data,$last_mod);
	}
}

function tb_rss($mid,$item,$no,$tb_data)
{
	global $g_burl,$g_cgi_name;

	// f[^ǂݍ
	list($tb_title,$tb_body) = unit_data("rss",$mid,$item,$no);

	foreach ($tb_data as $data) { // gbNobNꗗf[^
		list ($title, $description ,$link) = explode("\t",$data);
		$title = htmlspecialchars($title);
		$link = htmlspecialchars($link);
		$items.= <<<_ITEM_
   <item>
    <title>$title</title>
    <link>$link</link>
    <description>$description</description>
   </item>

_ITEM_;
	}
	$items.= '   </channel>';

	// f[^ݒ
	$link 
		= $g_burl .$g_cgi_name .'?id=' .get_id($mid, $item, $no);
	$description
		= mb_strimwidth(preg_replace("/[\r\n]/", ' ', $tb_body), 0, 255, '...');

	$response = <<<_XML_
<?xml version="1.0" encoding="utf-8" ?>
<response>
 <error>0</error>
 <rss version="0.91">
  <channel>
   <title>$tb_title</title>
   <link>$link</link>
   <description>$description</description>
   <language>ja</language>
$items
 </rss>
</response>
_XML_;

	header('Content-Type: text/xml');

	ob_start();
	print mb_convert_encoding($response, 'UTF-8', 'Shift-JIS');
	ob_end_flush();
	exit;
}

//
function tb_view($mid,$item,$no,$tb_data,$last_mod)
{
	global $g_burl,$g_tb_cgi,$g_bbs_title;

	header('Cache-control: no-cache');
	header('Pragma: no-cache');
	header('Content-type: text/html; charset=UTF-8');

	// f[^ǂݍ
	list($tb_title,$menu_name) = unit_data("view",$mid,$item,$no);

	$item_name = item_id_info($mid,$item);
	$rdf = make_tb_rdf($title,$mid,$item,$no);
	$id = get_id($mid, $item, $no);

	if ($tb_data) {
		foreach ($tb_data as $data) { // gbNobNꗗf[^
			list ($title, $description ,$link, $blog_name) = explode("\t",$data);
			$title = htmlspecialchars($title);
			$link = htmlspecialchars($link);
			$blog_name = htmlspecialchars($blog_name);
			$description = htmlspecialchars($description);
			$tb_list.= <<<_HTML_
<div class="list">
<table class="base">
<tr><td class="tb">
 <a href="$link">$title</a>
</td></tr>
<tr><td class="tb_body">
$description
</td></tr>
<tr><td class="tb_footer">
from: $blog_name
</td></tr></table>
</div>
_HTML_;
		}
		$tb_list.= "</table></div>\n";
	} else $tb_list = "<pre>1܂B</pre>";

	$body = <<<_HTML_
<head>
 <meta http-equiv="content-style-type" content="text/css" />
 <title>$tb_title - $g_bbs_title</title>
 <link rel="stylesheet" href="skin/pc.css.php" type="text/css" media="screen" charset="UTF-8" />
</head>
<body>
<div id="header">
	<h1 class="title"><u>$g_bbs_title<br>$menu_name / $item_name</u></h1>
</div>

<div id="last_mod">
	Last-modified: $last_mod
</div>

$rdf
<p>
<h5> $tb_title</h5>
@gbNobNID: {$g_burl}{$g_tb_cgi}?id=$id
<p>
<h6> gbNobNꗗ</h6>
$tb_list

</body>
</html>
_HTML_;

	ob_start();
	print mb_convert_encoding($body, 'UTF-8', 'SJIS');
	ob_end_flush();
	exit;
}

// gbNobÑ`FbN
function tb_check($url,$id)
{
	global $g_vars, $g_tb_max, $g_tb_link, $g_burl,$g_cgi_name;
	global $g_modvar,$g_tb,$g_tb_lastmod;
	$init = $g_vars;

	if (!$g_tb) tb_response(1,'Trackback is not usable.');
	if (!$g_modvar['tb']) tb_response(1,'Trackback is not usable.');
	if (!$url) tb_response(1,'URL is not found.');
	if (!$id) tb_response(1,'ID is wrong.');
	list($mid,$item,$no) = explode("_", $id);
	if (!$no) tb_response(1,'TrackBack ID is invalid.');

	if (!is_log(file_name("log",$mid,$item,$no)))
		tb_response(1,'TrackBack ID is invalid.');

	// gbNobNM̊mF
	if ($g_tb_link) {
		list($code,$data) = send_http($url);
		if ($code != 200) tb_response(1,'Your page is not found.');
		$my_url = $g_burl .$g_cgi_name .'?id=' .$id;
		if (!strpos($data,$my_url))
			tb_response(1,'Your page does not have a link to my page.');
	} else {
		list($code,$data) = send_http($url,"HEAD");
		if ($code != 200) tb_response(1,'Your page is not found.');
	}

	// gbNobNf[^ǂݍ
	$tb_file_name = file_name("tb",$mid,$item,$no);
	$tb_data = read_file($tb_file_name);
	if (!$tb_data) $tb_data = array();

	$tb_data_count = count($tb_data);
	if ($tb_data_count >= $g_tb_max)
		tb_response(1,'This page doesn not accept trackback anymore.');

	$t_tb['title'] = $init['title'];
	$t_tb['excerpt'] = $init['excerpt'];
	$t_tb['url'] = $init['url'];
	$t_tb['blog_name'] = $init['blog_name'];

	foreach ($t_tb as $key=>$value) {
		$moji_code = mb_detect_encoding($value,"SJIS, EUC-JP, UTF-8, JIS, ASCII");
		$value = htmlspecialchars($value);
		$value = preg_replace('/[\t\r\n]/s', '', $value);

		if ($moji_code != "SJIS" && $moji_code != '') {
			$tb[$key] = mb_convert_encoding($value, "SJIS", $moji_code);
		} else $tb[$key] = $value;
	}
	$t_tb['time'] = time();

	// df[^`FbN
	$i = 0;
	foreach ($tb_data as $tmp) {
		list ($title, $description ,$link, $blog_name) = explode("\t",$tmp);
		if (!strcmp($tb['url'],$link)) {
			array_splice($tb_data, $i, 1);
			$tb_check = TRUE;
			break;
		}
		++$i;
	}
	if ($tb_check) tb_response(1,'There is already your URL.');

	// f[^ݒ
	$set_data = join("\t",$tb)."\t\n";
	array_unshift($tb_data,$set_data);

	// 
	write_direct($tb_data, $tb_file_name, 84, 1);

	// ŏIXVt@C
	if ($g_tb_lastmod) {
		$file_name = file_name("log",$mid,$item,$no);
		if (!touch($file_name)) {
			$log_data = read_file($file_name);
			write_direct($log_data, $file_name, 12, 1);
		}

		modlog_lastmod($mid,$item,TRUE);
		modlog_lastmod($mid,$item,FALSE,FALSE);
		mbbs_lastmod();
	}

	tb_response(0,'');
}

// gbNobN̕ԐM
function tb_response($code,$msg)
{
	if ($code) $message = '<message>' .$msg ."</message>\n";
	$message.= '</response>';

	header('Content-Type: text/xml');

	$tb_res =  <<<_XML_
<?xml version="1.0" encoding="iso-8859-1"?>
<response>
<error>$code</error>
$message
_XML_;

	ob_start();
	print $tb_res;
	ob_end_flush();
	exit;
}

?>