<?php

//L[[h`FbN
function keyword_check($s_key)
{
	//Perl(p^[}b`)
	//http://www.din.or.jp/~ohzaki/perl.htm#JP_Match
	$eucpre = '(?<!\x8F)';
	$eucpost = '(?=(?:[\xA1-\xFE][\xA1-\xFE])*(?:[\x00-\x7F\x8E\x8F]|\z))';

	$keyword = array();
	foreach($s_key as $key){
		$key = htmlspecialchars($key);
		$keyword[] = $eucpre .'\Q' .$key .'\E' .$eucpost;
	}

	return $keyword;
}

// L[[hɂ郍O
function keyword_search($search_key,$search_range)
{
	global $g_burl,$g_cgi_name,$g_search_max;
	$func_data = array("search","","keyword_search");

	//L[[h
	if ($search_key) {
		$s_keys = array();
		$search_key = mb_convert_encoding($search_key,"EUC-JP","SJIS");
		$search_key = mb_convert_kana($search_key,"cs","EUC-JP");
		$search_key = mb_convert_kana($search_key,"akch","EUC-JP");
		$s_keys =
			keyword_check(preg_split('/\s+/', $search_key, -1, PREG_SPLIT_NO_EMPTY));
		$s_count = count($s_keys);
	} else $s_count = 0;

	//j[f[^ǂݍ
	$menu_data = read_file(file_name("menu"));

	if($menu_data) {
		$menu_list = array();
		$menu_name_list = array();
		foreach($menu_data as $menu_tmp){
			list($module,$id,$name) = explode("\t",$menu_tmp);
			$menu_list[] = $id;
			$menu_name_list[$id] = $name;
		}
	} else $search_error = TURE;

	if ($menu_list) { //Sitem擾
		$item_list = array();
		foreach ($menu_list as $menu_tmp) {
			$mlog = LOG_DIR .$menu_tmp .'.log';
			if (!is_log($mlog)) $mlog = array();
			else $menu_log = file($mlog);

			foreach ($menu_log as $menu_log_tmp) {
				$menu_log_tmp = preg_replace("/\n/", '', $menu_log_tmp);
				list($date,$item,$exp,$num) = explode("\t",$menu_log_tmp);
				if (!strcmp($search_range, "pt"))
					$item_list[] = $menu_tmp .'/' .$item .'-p';
				else
					$item_list[] = $menu_tmp .'/' .$item;
			}
		}
	}

	if ($item_list) { //SO擾
		$log_list = array();
		foreach ($item_list as $item_tmp) {
			$ilog = LOG_DIR .$item_tmp .'.log';
			if (!is_log($ilog)) $item_log = array();
			else $item_log = file($ilog);

			foreach ($item_log as $item_log_tmp) {
				$item_log_tmp = preg_replace("/\n/", '', $item_log_tmp);
				list($date,$log_name) = explode("\t",$item_log_tmp);
				if (!strcmp($log_name, "test")) continue;
				else $log_list[] = $item_tmp .'/' .$log_name;
			}
		}
	}

	if ($log_list) {
		foreach ($log_list as $log_tmp) {
			$llog = LOG_DIR .$log_tmp .'.log';
			if (!is_log($llog)) $log_data = array();
			else $log_data = file($llog);

			foreach ($log_data as $log_data_tmp){
				if (preg_match("/(<|>)/",$log_data_tmp)) continue;
				else $log_join_data.= $log_data_tmp;
			}
			$log_join_data =
				mb_convert_encoding($log_join_data,"EUC-JP","SJIS");
			$log_join_data =
				mb_convert_kana($log_join_data,"c","EUC-JP");
			$log_join_data =
				mb_convert_kana($log_join_data,"akch","EUC-JP");

			if ($s_count == 1) {
				if (preg_match("/$s_keys[0]/i",$log_join_data))
					$hit_logs[] = $log_tmp;
			} else {
				foreach ($s_keys as $s_key) {
					if (preg_match("/$s_key/i",$log_join_data)){
						$and_hit = 1;
						continue;
					} else {
						$and_hit = 0;
						break;
					}
				}
				if ($and_hit) $hit_logs[] = $log_tmp;
			}
			unset($log_join_data);
		}
	}

	$search_body.= <<<_HTML_
<h2>O</h2>
<p>
<h4></h4>
_HTML_;

	if($hit_logs) {
		$hit_count = count($hit_logs);

		switch (TRUE) {
			case (!is_numeric($g_search_max)):
			case (!$g_search_max):
				$g_search_max = 20;
				break;
			case ($g_search_max < 1):
				$g_search_max = 1;
				break;
			case ($g_search_max > 100):
				$g_search_max = 100;
				break;
		}
		if ($hit_count <= $g_search_max) {
			$g_search_max = $hit_count;
			$search_body.= "@" .$hit_count ."Hit<p>\n";
		} else {
			$search_body.= "@" .$hit_count ." {$g_search_max}\Ă܂B<p>\n";
		}
		$search_body.= "<ul>\n";

		for ($i = 0; $i < $g_search_max; ++$i) {
			$hit_log = array_shift($hit_logs);
			list($mid,$item,$no) = explode("/", $hit_log);
			list($menu_name,$module) = mid_info($mid);
			$item_name = item_id_info($mid,$item);

			$url = $g_burl . $g_cgi_name .'?id=' .get_id($mid, $item, $no);
			$link_name = $menu_name ." > " .$item_name ." > No." .$no;
			$search_body.= "<li><a href=\"{$url}\">" . $link_name ."</a>\n";
		}
		$search_body.= "</ul>\n";
	} else {
		if ($search_error)
			$search_body.= "@O܂B<p>";
		else 
			$search_body.= "@1qbg܂łB<p>";
	}

	return $search_body;
}

?>