<?php

// Track Back Ping M
function tbp_send($link_list,$title,$body,$menu,$item,$lno,$pid)
{
	global $g_bbs_title,$g_burl,$g_cgi_name,$g_tb_cgi;
	global $g_modvar,$g_tb;
	$tb_ver = '1.0';

	if (!$g_tb || $g_modvar['tb'] < 2) return;
	if ($g_modvar['tb_user'] == 0) if ($pid != "ad") return;

	$tb_data = array('title'=>$title, 'excerpt'=>mb_strimwidth(preg_replace("/[\r\n]/", ' ', $body), 0, 255, '...', "SJIS"), 'url'=>$g_burl .$g_cgi_name .'?id=' .$menu .'_' .$item .'_' .$lno, 'blog_name'=>$g_bbs_title .' [NA-multiBBS TrackBack ' .$tb_ver .']');

	$sjis_tb_data = array('title'=>$title, 'excerpt'=>mb_strimwidth(preg_replace("/[\r\n]/", ' ', $body), 0, 255, '...', "SJIS"), 'url'=>$g_burl .$g_cgi_name .'?id=' .$menu .'_' .$item .'_' .$lno, 'blog_name'=>$g_bbs_title .' [NA-multiBBS TrackBack ' .$tb_ver .']', 'charset'=>"Shift-JIS");

	// gbNobÑXgǂݍ
	$ltb_file_name = file_name("ltb",$menu,$item,$lno);
	$ltb_data = read_file($ltb_file_name);
	if (!$ltb_data) $ltb_data = array();

	foreach($link_list as $url) {
		if (in_array($url."\n",$ltb_data)) continue;
		else {
			$new_tb_list = TRUE;
			$ltb_data[] = $url."\n";
			list($send_url,$moji_code) = get_tb_url($url);

			if ($moji_code == "SJIS" || !$moji_code) $tb_data = $sjis_tb_data;
			else $tb_data = change_tb_data($tb_data,$moji_code);
			if ($send_url) list($code,$data) = send_http($send_url,"POST",$tb_data);
		}
	}
	if ($new_tb_list) write_direct($ltb_data, $ltb_file_name, 86, 1);
}

function change_tb_data($tb_data,$moji_code)
{
	$tb_data['charset'] = $moji_code;

	foreach($tb_data as $key=>$value) {
		$mcode = mb_detect_encoding($value,"SJIS, EUC-JP, UTF-8, JIS, ASCII");
		if ($mcode && $mcode != $moji_code)
			$ctb_data[$key] = mb_convert_encoding($value , $moji_code , "SJIS");
		else $ctb_data[$key] = $value;
	}

	return $ctb_data;
}

// RDFf[^gbNobNURL擾
function get_tb_url($url)
{
	list($code,$data) = send_http($url);

	if ($code != 200) return FALSE;
	if (!preg_match_all('#<rdf:Description(.*?)/>#si', $data, $matches, PREG_PATTERN_ORDER)) return FALSE;

	$moji_code = mb_detect_encoding($data,"SJIS, EUC-JP, UTF-8, JIS, ASCII");

	foreach ($matches[1] as $Description) {

		preg_match('/rdf:about=\"(.*?)\"/i', $Description, $d_matches);
		$about = $d_matches[1];
		preg_match('/dc:identifier=\"(.*?)\"/i', $Description, $d_matches);
		$id = $d_matches[1];
		preg_match('/trackback:ping=\"(.*?)\"/i', $Description, $d_matches);
		$tb_url = $d_matches[1];

		if (!strcmp($url,$about) || !strcmp($url,$id))
			return array($tb_url,$moji_code);
	}
	return array(FALSE,"");
}

// RDFf[^쐬
function make_tb_rdf($title,$menu,$item,$no)
{
	global $g_burl,$g_cgi_name,$g_tb_cgi; // $g_charser;

	$id = get_id($menu,$item,$no);

	$tb_rdf_data = <<<_RDF_
<!--
<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
         xmlns:dc="http://purl.org/dc/elements/1.1/"
         xmlns:trackback="http://madskills.com/public/xml/rss/module/trackback/">
<rdf:Description
     rdf:about="{$g_burl}$g_cgi_name?id=$id"
     dc:identifier="{$g_burl}$g_cgi_name?id=$id"
     dc:title="$title"
     trackback:ping="{$g_burl}$g_tb_cgi?id=$id" />
</rdf:RDF>
-->

_RDF_;

	return $tb_rdf_data;
}

// gbNobNf[^폜
function tb_del($menu,$item,$no)
{
	$file_name = file_name("tb",$menu,$item,$no);
	if (file_exists($file_name)) @unlink($file_name);
}

?>