@charset "Shift_JIS";

body {
	color:black;
	background-color:transparent;
	font-family:verdana, arial, sans-serif;
}

td {
	color:black;
	background-color:white;
	font-family:verdana, arial, sans-serif;
}

th {
	color:black;
	background-color:white;
	text-align: center;
	font-weight:bold;
	font-size:120%;
	font-family:verdana, arial, sans-serif;
}

a:link {
	color:#0055aa;
	background-color:inherit;
	text-decoration:none;
}
a:active {
	color:#0055aa;
	background-color:#CCDDEE;
	text-decoration:none;
}
a:visited {
	color:#aa5500;
	background-color:inherit;
	text-decoration:none;
}
a:hover {
	color:#222222;
	background-color:#CCDDEE;
	text-decoration:underline;
}

h1, h2 {
	color:inherit;
	padding:.3em;
	border:0px;
	margin:0px 0px .5em 0px;
	background-color: white;

	border-left:   2px solid black;
	border-right:   2px solid black;
	border-bottom:  5px solid black;
	border-top:     5px solid black;
	font-family:verdana, arial, sans-serif;
}

h3 {
	border-left:   18px solid black;
	border-right:   28px solid black;
	border-bottom:  2px solid black;
	border-top:     2px solid black;
	background-color: white;

	color:inherit;
	padding:.3em;
	margin:0px 0px .5em 0px;
	font-family:verdana, arial, sans-serif;
}

h4 {
	border-left:   10px solid black;
	border-right:   0px solid black;
	border-bottom:  2px solid black;
	border-top:     0px solid black;

	color:inherit;
	padding:.3em;
	margin:0px 0px .5em 0px;
	font-family:verdana, arial, sans-serif;
}

h5, h6 {
	color:inherit;
 	padding:.3em;
 	border:0px;
 	margin:0px 0px .5em 0px;

	border-left:   0px solid black;
	border-right:   0px solid black;
	border-bottom:  2px solid black;
	border-top:     0px solid black;
	font-family:verdana, arial, sans-serif;
}

h1.title {
	font-size: 30px;
	font-weight:bold;
	background-color:white;

	padding: 0px 0px 2px 5px;
	border: 0px;
	margin: 0px 0px 0px 0px;
}

h4.menu {
	text-align:center;
	padding: 0px 0px 0px 0px;
	border: 0px;
	margin: 0px 0px 0px 0px;
	color: white;
	background-color:white;

	border:  2px solid black;
}

h4#menu {
	margin: 4px 0px 0px 0px;
	background-color: #990000;
}
h4#search { background-color: #009900; }
h4#note { background-color: #000099; }
h4#skin { background-color: #009999; }

h6#m_note {
	padding: 0px 0px 0px 0px;
	border: 0px;
	margin: 4px 0px 0px 0px;
	color: white;
	background-color: #999999;
	text-align:center;

	border-left:black 10px solid;
	border-right:black 10px solid;
	border-bottom:  2px solid black;
	border-top:     2px solid black;
}

pre {
	border-top:black 1px solid;
	border-bottom:black 1px solid;
	border-left:black 1px solid;
	border-right:black 1px solid;
	padding:.5em;
	margin-left:1em;
	margin-right:2em;
	white-space:pre;
	color:black;
	background-color:white;
}
pre.cb {
	font-size: 12px;
	width: 580px;
	white-space:pre;
	border: black 1px solid;
	padding:2px;
	margin:5px 0px 5px 0px;
	white-space:pre;
	color:black;
	background-color: white;
	font-family:monospace;
}

img {
	border:none;
	vertical-align:middle;
}

ul {
	margin-left: 16px;
	margin-top:.5em;
	margin-bottom:.5em;
	line-height:130%;
}
hr {
	border-color: black;
	border-width: 2px 0px 0px 0px;
}

/* skin */
table#contents {
	width: 100%;

	border-top:#000000 2px solid;
	border-bottom:#000000 2px solid;
}
td.menubar {
	width:160px;
	vertical-align:top;

	padding:0px;
	margin:0px 0px 0px 0px;
	background-color:transparent;
}
div#menubar {
	padding: 5px 0px 5px 0px;
	margin:0px 0px 4px 0px;
	background-color: white;

	border-left:black 2px solid;
	border-right:black 2px solid;
	border-bottom:black 2px solid;
}
div#menubar ul {
	margin:2px 0px 2px 16px;
	padding:0px 0px 0px .5em;
}

td.body {
	vertical-align:top;

	padding:0px;
	margin:0px 0px 0px 0px;
	background-color:transparent;
	width: auto;
}
div#body {
	padding:4px;
	margin:4px 0px 4px .5em;

	border: black 2px solid;
	background-color:#F4F4FF;
}
div#header {
	border-left:#000000 2px solid;
	border-top:#000000 2px solid;
	border-right:#000000 2px solid;
	padding:0px;
	margin:0px;
}
div#mod_footer {
	text-align: right;
	font-size:80%;
	padding:0px;
	margin:0px 0px 0px 0px;
}
div#last_mod {
	font-size:60%;
	text-align: right;
	padding:0px;
	margin:0px;
	color: white;
	background-color:#000000;
}
div#s_form { text-align: center; }
div.auto { width: 100%; }
div#mod_admin {
	background-color: #BBEEBB;
	padding: 4px;
	width:100%;
}
td.mv_exp {
	font-weight:bold;
	background-color: #EEDDDD;
}
div.list {
	margin: 5px 0px 5px 0px;
	width: 100%;
}

/* footer */

ul.footer {
	margin:0px;
	padding:0px;
	text-align:center;
}

div#footer {
	font-size:80%;
	padding:0px;
	margin:3px 0px 0px 0px;
}

/* update */
span.update1
{
	color:red;
	background-color:transparent;
	font-size:small;
}
span.update2
{
	color:#990000;
	background-color:transparent;
	font-size:x-small;
}
span.update3
{
	color:green;
	background-color:transparent;
	font-size:xx-small;
}

/* navi */
div#navi {
	text-align: right;
	padding:0px;
	margin:3px;
}

ul.navi {
	margin:0px;
	padding:0px;
	text-align:center;
}

/* li */
li.none {
	display:inline;
	float:none;
}
li.left {
	display:inline;
	float:left;
	text-align:left;
}
li.right {
	display:inline;
	float:right;
	text-align:right;
}

/* table */
table.base {
	border-spacing: 1px;
	background-color: black;
	border-width: 0px;
	width: 100%;
}
td.admin { background-color: #FAFAEF; }
td.user { background-color: #FAEFFA; }

th.i_white {
	background-color:white;
}
th.i_sol {
	background-color: #FAFFFA;
}
td.i_p {
	background-color: #F9F9F9;
	padding: 4px;
}
td.i_res {
	text-align: center;
	background-color: #FFFAFA;
}

/* basic module */
td.co_data { background-color: #EFFAFA; }
td.co_p {
	background-color: #F9F9F9;
	padding: 4px;
}
td.co_title {
	font-size: 120%;
	color: white;
	background-color: #009400;
	vertical-align: bottom;
	border: double white 1px;
}
td.co_body {
	padding: 5px;
	background-color: #FFFFFF;
}
td.co_time {
	font-size: 70%;
	color: white;
	background-color: #333333;
}
td.co_sol {
	text-align: center;
	background-color: #FAFFFA;
}
td.co_res {
	text-align: center;
	background-color: #FFFAFA;
}
td.co_attach {
	padding: 5px;
	height: 74px;
	background-color: #FFF8DC;
}
th.bs_white
{
	background-color:white;
}

td.re_name { background-color: #FAEFEF; }
td.re_body {
	padding: 5px;
	background-color: #FFFFFF;
}
td.re_time
{
	font-size: 60%;
	color: white;
	background-color: #AAAAAA;
}
td.re_attach {
	padding: 5px;
	height: 74px;
	background-color: #FFF8DC;
}
div.no_re
{
	font-size: 120%;
	color: red;
}

/* qanda module */
td.ques_data { background-color: #EFFAFA; }
td.ques_p {
	background-color: #F9F9F9;
	padding: 4px;
}
td.ques_title {
	font-size: 120%;
	color: white;
	background-color: #009400;
	vertical-align: bottom;
	border: double white 1px;
}
td.ques_body {
	padding: 5px;
}
td.ques_time {
	font-size: 70%;
	color: white;
	background-color: #333333;
}
td.ques_sol {
	text-align: center;
	background-color: #FAFFFA;
}
td.ques_res {
	text-align: center;
	background-color: #FFFAFA;
}
th.qa_white
{
	background-color:white;
}

td.ans_name { background-color: #FAEFEF; }
td.ans_body {
	padding: 5px;
	background-color: #FFFFFF;
}
td.ans_time
{
	font-size: 60%;
	color: white;
	background-color: #AAAAAA;
}
td.ans_attach {
	padding: 5px;
	height: 74px;
	background-color: #FFF8DC;
}
div.no_ans
{
	font-size: 120%;
	color: red;
}

/* opinion module */
td.op_data { background-color: #EFFAFA; }
td.op_p {
	background-color: #F9F9F9;
	padding: 4px;
}
td.op_title {
	font-size: 120%;
	color: white;
	background-color: #009400;
	vertical-align: bottom;
	border: double white 1px;
}
td.op_body {
	padding: 5px;
	background-color: #FFFFFF;
}
td.op_time {
	font-size: 70%;
	color: white;
	background-color: #333333;
}
td.op_sol {
	text-align: center;
	background-color: #FAFFFA;
}
td.op_res {
	text-align: center;
	background-color: #FFFAFA;
}
th.op_white
{
	background-color:white;
}

/* trackback */
div#tb { font-size: 80%; }
td.tb { font-size: 120%; }
td.tb_body {
	font-size: 80%;
	background-color: #FFFFF0;
	padding: 3px;
}
td.tb_footer {
	font-size: 70%;
	color: white;
	background-color: #AAAAAA;
}

/* text color */
div#black{ color: black; }
div#red{ color: red; }
div#green{ color: green; }
div#blue{ color: blue; }
div#orange{ color: orange; }
div#magenta{ color: magenta; }
div#darkcyan{ color: darkcyan; }

/* background color */
td#black{  background-color: black; }
td#white{  background-color: white; }
td#ivory{ background-color: ivory; }
td#honeydew{ background-color: honeydew; }
td#azure{ background-color: azure; }
td#lavenderblush{ background-color: lavenderblush; }
td#lightcyan{ background-color: lightcyan; }
td#lavender{ background-color: lavender; }

/* img */
.fleft { float: left; }
